package ${project_rootPackage};

<%if (platform_7_2_plus) {
%>import com.haulmont.cuba.testsupport.TestContainer;
import org.junit.jupiter.api.extension.ExtensionContext;

import java.util.ArrayList;
import java.util.Arrays;<%
} else {
%>import com.haulmont.bali.util.Dom4j;
import com.haulmont.cuba.testsupport.TestContainer;
import org.dom4j.Document;
import org.dom4j.Element;

import java.io.File;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Optional;<%
}%>

public class ${test_container_prefix}TestContainer extends TestContainer {

    public ${test_container_prefix}TestContainer() {
        super();
        //noinspection ArraysAsListWithZeroOrOneArgument
        appComponents = new ArrayList<>(Arrays.asList(
                <% if (platform_7_0_plus) {
                %>// list add-ons here: "com.haulmont.reports", "com.haulmont.addon.bproc", etc.<%
                } else {%>// add CUBA premium add-ons here:
                // "com.haulmont.bpm",
                // "com.haulmont.charts",
                // "com.haulmont.fts",
                // "com.haulmont.reports",
                // ...and custom app components if any<%}%>
                "com.haulmont.cuba"
        ));
        appPropertiesFiles = Arrays.asList(
                // List the files defined in your web.xml
                // in appPropertiesConfig context parameter of the core module
                "${project_rootPath}/app.properties",
                // Add this file which is located in CUBA and defines some properties
                // specifically for test environment. You can replace it with your own
                // or add another one in the end.
                "${ platform_7_2_plus ? project_rootPath + '/' :  platform_7_0_plus ? 'com/haulmont/cuba/testsupport/' : '' }test-app.properties");
        <%if (platform_7_2_plus) {%>autoConfigureDataSource();<%} else {%>initDbProperties();<%}%>
    }

    <%if (!platform_7_2_plus) {%>private void initDbProperties() {
        File contextXmlFile = new File("modules/core/web/META-INF/context.xml");
        if (!contextXmlFile.exists()) {
            contextXmlFile = new File("web/META-INF/context.xml");
        }

        if (!contextXmlFile.exists()) {
            throw new RuntimeException("Cannot find 'context.xml' file to read database connection properties. " +
                    "You can set them explicitly in this method.");
        }
        Document contextXmlDoc = Dom4j.readDocument(contextXmlFile);
        Element resourceElem = contextXmlDoc.getRootElement().element("Resource");

        Optional.ofNullable(resourceElem.attributeValue("driverClassName")).ifPresent(e -> dbDriver = e);
        Optional.ofNullable(resourceElem.attributeValue("url")).ifPresent(e -> dbUrl = e);
        Optional.ofNullable(resourceElem.attributeValue("username")).ifPresent(e -> dbUser = e);
        Optional.ofNullable(resourceElem.attributeValue("password")).ifPresent(e -> dbPassword = e);
    }<%}%>

    public static class Common extends ${test_container_prefix}TestContainer {

        public static final ${test_container_prefix}TestContainer.Common INSTANCE = new ${test_container_prefix}TestContainer.Common();

        private static volatile boolean initialized;

        private Common() {
        }

        <%if (platform_7_2_plus) {
        %>@Override
        public void beforeAll(ExtensionContext extensionContext) throws Exception {
            if (!initialized) {
                super.beforeAll(extensionContext);
                initialized = true;
            }
            setupContext();
        }
        <%} else {
        %>@Override
        public void before() throws Throwable {
            if (!initialized) {
                super.before();
                initialized = true;
            }
            setupContext();
        }<%}%>

        <%if (platform_7_2_plus) {
        %>@SuppressWarnings("RedundantThrows")
        @Override
        public void afterAll(ExtensionContext extensionContext) throws Exception {
            cleanupContext();
            // never stops - do not call super
        }
        <%} else {
        %>@Override
        public void after() {
            cleanupContext();
            // never stops - do not call super
        }<%}%>
    }
}