package ${project_rootPackage}.core;

import ${project_rootPackage}.${test_container_prefix}TestContainer;
import com.haulmont.cuba.core.EntityManager;
import com.haulmont.cuba.core.Persistence;
import com.haulmont.cuba.core.Transaction;
import com.haulmont.cuba.core.TypedQuery;
import com.haulmont.cuba.core.global.AppBeans;
import com.haulmont.cuba.core.global.DataManager;
import com.haulmont.cuba.core.global.Metadata;
import com.haulmont.cuba.security.entity.User;<%if (platform_7_2_plus) {%>
import org.junit.jupiter.api.*;
import org.junit.jupiter.api.extension.RegisterExtension;<%} else {%>
import org.junit.*;<%}%>

import java.util.List;

public class SampleIntegrationTest {

    ${ platform_7_2_plus ? '@RegisterExtension' : '@ClassRule' }
    public static ${test_container_prefix}TestContainer cont = ${test_container_prefix}TestContainer.Common.INSTANCE;

    private static Metadata metadata;
    private static Persistence persistence;
    private static DataManager dataManager;

    ${ platform_7_2_plus ? '@BeforeAll' : '@BeforeClass' }
    public static void ${ platform_7_2_plus ? 'beforeAll()' : 'setUp()' } throws Exception {
        metadata = cont.metadata();
        persistence = cont.persistence();
        dataManager = AppBeans.get(DataManager.class);
    }

    ${ platform_7_2_plus ? '@AfterAll' : '@AfterClass' }
    public static void ${ platform_7_2_plus ? 'afterAll()' : 'tearDown()' } throws Exception {
    }

    @Test
    public void testLoadUser() {
        try (Transaction tx = persistence.createTransaction()) {
            EntityManager em = persistence.getEntityManager();
            TypedQuery<User> query = em.createQuery(
                    "select u from sec\$User u where u.login = :userLogin", User.class);
            query.setParameter("userLogin", "admin");
            List<User> users = query.getResultList();
            tx.commit();
            ${ platform_7_2_plus ? 'Assertions' : 'Assert' }.assertEquals(1, users.size());
        }
    }
}